import { OnceInit } from "./once-init";
export * from "./once-init";
export declare const version: string;
export declare function oi<T, P extends Array<any>>(promise: (...param: P) => Promise<T>): OnceInit<T, P>;
export default oi;
/**
 * 把对象的所有的Function都修改成Async Function
 */
type K<T> = {
    [k in keyof T]: T[k] extends (...args: any) => any ? (...args: Parameters<T[k]>) => Promise<Awaited<ReturnType<T[k]>>> : T[k];
};
/**
 * 把对象的所有方法都修改成once-init的refresh方法
 *
 * 即防止对象的所有方法在同一时间执行多次
 *
 * @param obj 被封装的对象
 * @deprecated 该api仍处于测试状态
 * @returns
 */
export declare function packagedByRefresh<T extends object>(obj: T): K<T> & {
    oiSource: T;
};
//# sourceMappingURL=index.d.ts.map