export declare class OnceInit<T, P extends Array<any> = []> {
    protected _promiseFunction: (...param: P) => Promise<T>;
    protected _processedParams: P[];
    protected _returnValueList: Array<T>;
    protected _promiseList: Array<Promise<T> | null>;
    constructor(initPromise: (...param: P) => Promise<T>);
    /** 清空某个参数的缓存 */
    clear(...params: P | []): void;
    /** 初始化，returnValueMap中对应的参数存在变量，则不会再请求 */
    init: (...param: P) => Promise<T>;
    /** 刷新，如果存在正在执行的对应参数的Promise，则不会创建新的Promise */
    refresh: (...param: P) => Promise<T>;
    send: (...param: P) => Promise<T>;
    request: (...param: P) => Promise<T>;
    /** 同步获取值，如果参数存在返回值，则返回，否则返回undefined */
    get: (...param: P) => T | undefined;
    /**
     * 强制执行，无论对应参数的Promise是否正在执行，都创建一个新的promise执行
     * 并覆盖在执行中的promise
     *
     * 类似于取消重复的Promise
     * @param param
     * @returns
     */
    exceed: (...param: P) => Promise<T>;
    /**
     * 执行源函数
     * @param param
     * @returns
     */
    execute: (...param: P) => Promise<T>;
    /**
     * 等待param对应的promise执行结束，如果当前没有正在执行的对应的promise，将不会执行等待
     * 否则等待执行直到没有对应的promise
     * exceed会推迟wait的执行返回
     * @param param
     */
    wait: (...param: P) => Promise<void>;
    get promiseFunction(): (...param: P) => Promise<T>;
    get processedParams(): P[];
    get returnValueList(): T[];
    get promiseList(): (Promise<T> | null)[];
    private getParamIndex;
}
//# sourceMappingURL=once-init.d.ts.map